Attribute VB_Name = "MdlImageGPS"
Option Explicit
'------------------------------
'Autor: Leandro Ascierto
'Web: www.leandroascierto.com
'Date: 28/02/2013
'------------------------------
Private Declare Function GdiplusStartup Lib "gdiplus" (ByRef token As Long, ByRef lpInput As GdiplusStartupInput, Optional ByRef lpOutput As Any) As Long
Private Declare Function GdiplusShutdown Lib "gdiplus" (ByVal token As Long) As Long
Private Declare Function GdipGetPropertyCount Lib "GdiPlus.dll" (ByVal mImage As Long, ByRef mNumOfProperty As Long) As Long
Private Declare Function GdipGetPropertyItem Lib "GdiPlus.dll" (ByVal mImage As Long, ByVal mPropId As Long, ByVal mPropSize As Long, ByRef mBuffer As Any) As Long
Private Declare Function GdipGetPropertyItemSize Lib "GdiPlus.dll" (ByVal mImage As Long, ByVal mPropId As Long, ByRef msize As Long) As Long
Private Declare Function GdipGetPropertySize Lib "GdiPlus.dll" (ByVal mImage As Long, ByRef mTotalBufferSize As Long, ByRef mNumProperties As Long) As Long
Private Declare Function GdipGetAllPropertyItems Lib "GdiPlus.dll" (ByVal mImage As Long, ByVal mTotalBufferSize As Long, ByVal mNumProperties As Long, ByRef mAllItems As Any) As Long
Private Declare Function GdipRemovePropertyItem Lib "GdiPlus.dll" (ByVal mImage As Long, ByVal mPropId As Long) As Long
Private Declare Function GdipSetPropertyItem Lib "GdiPlus.dll" (ByVal mImage As Long, ByRef mItem As Any) As Long
Private Declare Function GdipLoadImageFromFile Lib "GdiPlus.dll" (ByVal mFilename As String, ByRef mImage As Long) As Long
Private Declare Function GdipDisposeImage Lib "GdiPlus.dll" (ByVal mImage As Long) As Long
Private Declare Function GdipSaveImageToFile Lib "gdiplus" (ByVal image As Long, ByVal FileName As Long, ByRef clsidEncoder As GUID, ByRef encoderParams As Any) As Long
Private Declare Function CLSIDFromString Lib "ole32" (ByVal str As Long, id As GUID) As Long
  
Private Const ImageCodecJPG                 As String = "{557CF401-1A04-11D3-9A73-0000F81EF32E}"

Private Const PropertyTagGpsLatitudeRef     As Long = &H1
Private Const PropertyTagGpsLatitude        As Long = &H2
Private Const PropertyTagGpsLongitudeRef    As Long = &H3
Private Const PropertyTagGpsLongitude       As Long = &H4
Private Const PropertyTagGpsAltitudeRef     As Long = &H5
Private Const PropertyTagGpsAltitude        As Long = &H6

Private Const PropertyTagTypeASCII          As Long = &H2
Private Const PropertyTagTypeRational       As Long = &H5

Private Type GdiplusStartupInput
    GdiplusVersion              As Long
    DebugEventCallback          As Long
    SuppressBackgroundThread    As Long
    SuppressExternalCodecs      As Long
End Type

Private Type GUID
    Data1           As Long
    Data2           As Integer
    Data3           As Integer
    Data4(0 To 7)   As Byte
End Type


'Only JPG or JPEG
'Not support XMP
Public Function ReadImageGPS(ByVal sPath As String, ByRef Latitude As Double, ByRef Longitude As Double) As Boolean
    Dim GdipToken As Long
    Dim hImage As Long
    Dim lNumOfProperty As Long
    Dim tProp() As Long
    Dim nSize As Long
    Dim Degrees As Double
    Dim Minutes As Double
    Dim Seconds As Double
    Dim Coorditate  As Double
    Dim sGEO As String
    

    Dim GdipStartupInput As GdiplusStartupInput
    GdipStartupInput.GdiplusVersion = 1&
    If GdiplusStartup(GdipToken, GdipStartupInput, ByVal 0) <> 0 Then Exit Function
    
    If GdipLoadImageFromFile(StrConv(sPath, vbUnicode), hImage) = 0 Then
    
        If GdipGetPropertyCount(hImage, lNumOfProperty) = 0 Then

            If lNumOfProperty > 0 Then

                If GdipGetPropertyItemSize(hImage, PropertyTagGpsLatitude, nSize) = 0 Then
                   
                    If nSize Then
                
                        ReDim tProp((nSize / 4) - 1)
                        
                        '---Latitud
                        If GdipGetPropertyItem(hImage, PropertyTagGpsLatitude, nSize, tProp(0)) = 0 Then
                            Degrees = tProp(4) / tProp(5)
                            Minutes = tProp(6) / tProp(7)
                            Seconds = tProp(8) / tProp(9)
                                                        
                            If GdipGetPropertyItemSize(hImage, PropertyTagGpsLatitudeRef, nSize) = 0 Then
                                ReDim tProp((nSize / 4) - 1)
                                If GdipGetPropertyItem(hImage, PropertyTagGpsLatitudeRef, nSize, tProp(0)) = 0 Then
                                    sGEO = UCase(Chr(tProp(4)))
                                End If
                            End If
                        
                            If sGEO = "S" Then 'South/Sur
                                Latitude = -(Degrees + (Minutes / 60) + (Seconds / 3600))
                            Else 'North/Norte
                                Latitude = Degrees + (Minutes / 60) + (Seconds / 3600)
                            End If
                            
                            '--- Longitud
                            If GdipGetPropertyItemSize(hImage, PropertyTagGpsLongitude, nSize) = 0 Then
                
                                If nSize Then
                                
                                    ReDim tProp((nSize / 4) - 1)
                                    
                                    If GdipGetPropertyItem(hImage, PropertyTagGpsLongitude, nSize, tProp(0)) = 0 Then
                                        Degrees = tProp(4) / tProp(5)
                                        Minutes = tProp(6) / tProp(7)
                                        Seconds = tProp(8) / tProp(9)

                                        If GdipGetPropertyItemSize(hImage, PropertyTagGpsLongitudeRef, nSize) = 0 Then
                                            ReDim tProp((nSize / 4) - 1)
                                            If GdipGetPropertyItem(hImage, PropertyTagGpsLongitudeRef, nSize, tProp(0)) = 0 Then
                                                sGEO = UCase(Chr(tProp(4)))
                                            End If
                                        End If
                                    
                                        If sGEO = "W" Or sGEO = "O" Then 'W = West, O = Oeste(Spanish)
                                            Longitude = -(Degrees + (Minutes / 60) + (Seconds / 3600))
                                        Else 'East/Este
                                            Longitude = Degrees + (Minutes / 60) + (Seconds / 3600)
                                        End If

                                        ReadImageGPS = True
            
                                    End If
                            
                                End If
                            
                            End If
                            '-------

                        End If
                
                    End If
                
                End If
                
            End If
                
         End If
         
         GdipDisposeImage hImage
         
    End If

    Call GdiplusShutdown(GdipToken)

End Function

'Only JPG or JPEG
'Not support XMP
Public Function WriteImageGPS(ByVal sPath As String, ByVal Latitude As Double, ByVal Longitude As Double) As Boolean
    Dim GdipStartupInput As GdiplusStartupInput
    Dim GdipToken As Long
    Dim hImage As Long
    Dim lNumOfProperty As Long
    Dim tProp() As Long
    Dim nSize As Long
    Dim Degrees As Double
    Dim Minutes As Double
    Dim Seconds As Double
    Dim sGEO As String
    Dim tEncoder  As GUID
    Dim sExt As String
    Dim lPos As Long
    Dim ArrLng() As Long

    sPath = Trim(sPath)
    
    lPos = InStrRev(sPath, ".")
    If lPos Then
        sExt = UCase(Right(sPath, Len(sPath) - lPos))
    End If
    
    If (sExt <> "JPG") And (sExt <> "JPEG") Then Exit Function

    GdipStartupInput.GdiplusVersion = 1&
    If GdiplusStartup(GdipToken, GdipStartupInput, ByVal 0) <> 0 Then Exit Function
    
    If GdipLoadImageFromFile(StrConv(sPath, vbUnicode), hImage) = 0 Then

        ReDim tProp(3)
        ReDim ArrLng(5)
        
        DecimalToGMS Latitude, Degrees, Minutes, Seconds
        
        ArrLng(0) = Degrees * 100000
        ArrLng(1) = 100000
        ArrLng(2) = CLng((Minutes * 100000) + (Seconds / 3600 * 60 * 100000))
        ArrLng(3) = 100000
        ArrLng(4) = 0
        ArrLng(5) = 100000
        
        tProp(0) = PropertyTagGpsLatitude
        tProp(1) = 24 'Size of ArrLng
        tProp(2) = PropertyTagTypeRational
        tProp(3) = VarPtr(ArrLng(0))

        If GdipSetPropertyItem(hImage, tProp(0)) <> 0 Then GoTo Abort
        
        sGEO = IIf(Latitude < 0, "S", "N") '& Chr(0)
    
        tProp(0) = PropertyTagGpsLatitudeRef
        tProp(1) = 2 '(one character plus the NULL terminator)
        tProp(2) = PropertyTagTypeASCII
        tProp(3) = StrPtr(sGEO)
            
        If GdipSetPropertyItem(hImage, tProp(0)) <> 0 Then GoTo Abort

        DecimalToGMS Longitude, Degrees, Minutes, Seconds

        ArrLng(0) = Degrees * 100000
        ArrLng(1) = 100000
        ArrLng(2) = CLng((Minutes * 100000) + (Seconds / 3600 * 60 * 100000))
        ArrLng(3) = 100000
        ArrLng(4) = 0
        ArrLng(5) = 100000
        
        tProp(0) = PropertyTagGpsLongitude
        tProp(1) = 24 'Size of ArrLng
        tProp(2) = PropertyTagTypeRational
        tProp(3) = VarPtr(ArrLng(0))

        If GdipSetPropertyItem(hImage, tProp(0)) <> 0 Then GoTo Abort
        
        sGEO = IIf(Longitude < 0, "W", "E")
        
        tProp(0) = PropertyTagGpsLongitudeRef
        tProp(1) = 2 '(one character plus the NULL terminator)
        tProp(2) = PropertyTagTypeASCII
        tProp(3) = StrPtr(sGEO)

            
        If GdipSetPropertyItem(hImage, tProp(0)) <> 0 Then GoTo Abort

        CLSIDFromString StrPtr(ImageCodecJPG), tEncoder
        
        If GdipSaveImageToFile(hImage, StrPtr(sPath & "_Temp"), tEncoder, ByVal 0&) = 0 Then
            GdipDisposeImage hImage
            
            On Error Resume Next
            Kill sPath
            If Err.Number = 0 Then
                Name sPath & "_Temp" As sPath
                If Err.Number = 0 Then WriteImageGPS = True
            Else
                Kill sPath & "_Temp"
                Err.Clear
            End If
        Else
            GdipDisposeImage hImage
        End If
 
    End If

    Call GdiplusShutdown(GdipToken)
    Exit Function
    
Abort:
    GdipDisposeImage hImage
    Call GdiplusShutdown(GdipToken)
End Function

Public Function DecimalToGMS(Value As Double, Grado As Double, Minuto As Double, Segundo As Double)
    Dim Absolute As Double
    Dim pEntera As Double, pDecimal As Double

    Absolute = Abs(Value)

    pEntera = Fix(Absolute)
    pDecimal = Absolute - pEntera
    
    Grado = pEntera
    Absolute = pDecimal * 60

    pEntera = Fix(Absolute)
    pDecimal = Absolute - pEntera
    
    If pEntera <> Absolute Then
    Minuto = pEntera
    End If
    
    Segundo = pDecimal * 60

End Function

Public Function GMSToDecimal(Grado As Double, Minuto As Double, Segundo As Double) As Double
    GMSToDecimal = Grado + (Minuto / 60) + (Segundo / 3600)
End Function

